## nvme-stas 2.2.1

=== Makefile ===
# Copyright (c) 2021, Dell Inc. or its subsidiaries.  All rights reserved.
# SPDX-License-Identifier: Apache-2.0
# See the LICENSE file for details.
#
# This file is part of NVMe STorage Appliance Services (nvme-stas).
#
# Authors: Martin Belanger <Martin.Belanger@dell.com>
#
.DEFAULT_GOAL     := stas
BUILD-DIR         := .build
DEB-PKG-DIR       := ${BUILD-DIR}/deb-pkg
RPM-BUILDROOT-DIR := ${BUILD-DIR}/rpmbuild

ifneq (,$(strip $(filter $(MAKECMDGOALS),rpm deb dist)))
  XTRA-MESON-OPTS := --wrap-mode=nodownload
endif

.PHONY: update-subprojects
update-subprojects:
	meson subprojects update

${BUILD-DIR}:
	BUILD_DIR=${BUILD-DIR} ./configure ${XTRA-MESON-OPTS}
	@echo "Configuration located in: $@"
	@echo "-------------------------------------------------------"

.PHONY: stas
stas: ${BUILD-DIR}
	ninja -C ${BUILD-DIR}

.PHONY: clean
clean:
ifneq ("$(wildcard ${BUILD-DIR})","")
	ninja -C ${BUILD-DIR} -t clean
endif

.PHONY: purge
purge:
ifneq ("$(wildcard ${BUILD-DIR})","")
	rm -rf ${BUILD-DIR}
endif

.PHONY: install
install: stas
	sudo meson $@ -C ${BUILD-DIR} --skip-subprojects

.PHONY: uninstall
uninstall: ${BUILD-DIR}
	sudo ninja -C ${BUILD-DIR} uninstall

.PHONY: dist
dist: stas
	meson $@ -C ${BUILD-DIR} --formats gztar

.PHONY: test
test: stas
	meson $@ -C ${BUILD-DIR} --suite nvme-stas

.PHONY: loc
loc:
	@cloc --by-file --exclude-dir=${BUILD-DIR},doc,subprojects,test,utils,debian,obj-x86_64-linux-gnu,.github --exclude-lang=Markdown,"NAnt script",XML,"Bourne Again Shell",make,"Bourne Shell",Meson,YAML,XSLT .

.PHONY: loc-full
loc-full:
	@cloc --by-file --exclude-dir=${BUILD-DIR},subprojects,debian,obj-x86_64-linux-gnu,.github .

.PHONY: black
black:
	black --diff --color --line-length 120 --skip-string-normalization --extend-exclude="(subprojects|debian|.build)" .

# Coverage requirements:
#   pip install coverage
.PHONY: coverage
coverage: stas
	cd ${BUILD-DIR} && ./coverage.sh

################################################################################
# Debian (*.deb)
# Use "DEB_BUILD_OPTIONS=nocheck make deb" to skip unit testing.
# This requires: sudo apt install -y debhelper dh-python
ifeq (deb,$(strip $(MAKECMDGOALS)))
  ifneq (SUCCESS,$(shell dpkg -s debhelper dh-python > /dev/null 2>&1 && echo "SUCCESS" || echo "FAIL"))
    $(error Missing packages. Run -> "sudo apt install -y debhelper dh-python")
  endif
endif

.PHONY: deb
deb: ${BUILD-DIR}
	mkdir -p ${DEB-PKG-DIR}
	dpkg-buildpackage -us -uc
	@mv ../nvme-stas_*.deb ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.buildinfo ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.changes ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.dsc ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.tar.gz ${DEB-PKG-DIR}
	@echo "======================================================="
	@echo "Debian packages located in: ${DEB-PKG-DIR}/"


################################################################################
# RedHat (*.rpm)
${BUILD-DIR}/nvme-stas.spec: ${BUILD-DIR} nvme-stas.spec.in
	meson --wrap-mode=nodownload --reconfigure ${BUILD-DIR}

${RPM-BUILDROOT-DIR}: ${BUILD-DIR}/nvme-stas.spec
	rpmbuild -ba $< --build-in-place --clean --nocheck --define "_topdir $(abspath ${BUILD-DIR}/rpmbuild)"
	@echo "======================================================="
	@echo "RPM packages located in: ${RPM-BUILDROOT-DIR}/"

.PHONY: rpm
rpm: ${RPM-BUILDROOT-DIR}

=== debian/changelog ===
nvme-stas (2.2.1-1~ubuntu22.04) jammy; urgency=medium

  * Backport to jammy (LP: #2020461)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 23 May 2023 14:09:17 +0200

nvme-stas (2.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #1032650)

 -- Benjamin Drung <bdrung@debian.org>  Thu, 06 Apr 2023 13:51:59 +0200

=== debian/control ===
Source: nvme-stas
Section: net
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Uploaders: Benjamin Drung <bdrung@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               docbook-xml,
               docbook-xsl,
               iproute2,
               libglib2.0-dev-bin,
               meson,
               pyflakes3,
               pylint,
               python3-dasbus,
               python3-gi,
               python3-lxml,
               python3-nvme,
               python3-pyfakefs,
               python3-pyudev,
               python3-systemd,
               python3:any,
               xsltproc
Standards-Version: 4.6.2
Homepage: https://github.com/linux-nvme/nvme-stas
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/nvme-stas
Vcs-Git: https://salsa.debian.org/debian/nvme-stas.git

Package: nvme-stas
Architecture: all
Depends: python3-dasbus,
         python3-gi,
         python3-nvme,
         python3-pyudev,
         python3-systemd,
         ${misc:Depends},
         ${python3:Depends}
Description: NVMe STorage Appliance Services
 This package provides two daemons, stafd and stacd. The STorage Appliance
 Finder Daemon (stafd) automatically discovers NVMe-oF Discovery Controllers
 (DC) and retrieves the list of NVMe Storage Appliances. The STorage Appliance
 Connector Daemon (stacd) establishes I/O connections to the NVMe Storage
 Appliances discovered by stafd.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=meson+ninja --with python3

override_dh_auto_configure:
	dh_auto_configure -- -Dman=true

=== debian/tests/control ===
Test-Command: cp -r test "$AUTOPKGTEST_TMP" && cd "$AUTOPKGTEST_TMP/test" && rm test-avahi.py && python3 -m unittest -v test*.py
Depends: iproute2, nvme-stas, python3-pyfakefs
Restrictions: allow-stderr
Features: test-name=unittest

=== debian/watch ===
version=4
opts="compression=gzip,searchmode=plain" \
  https://api.github.com/repos/linux-nvme/nvme-stas/releases?per_page=100 \
  https://api.github.com/repos/linux-nvme/nvme-stas/tarball/v@ANY_VERSION@

## nvme-stas 2.2.2

=== debian/changelog ===
nvme-stas (2.2.2-2) unstable; urgency=medium

  [ Mateus Rodrigues de Morais ]
  * d/p/Fix-byte-ordering-in-iputil-operations.patch: make byteorder
    architecture-aware in order to fix s390x autopkgtest failures.
    (LP: #2026878)

 -- Benjamin Drung <bdrung@debian.org>  Tue, 05 Sep 2023 13:45:22 +0200

nvme-stas (2.2.2-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 2.2.2.
  * Updating vcs fields.
  * Updating year in copyright for 2023.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 10 Jun 2023 11:02:13 +0200

nvme-stas (2.2.1-2) sid; urgency=medium

  * Uploading to sid.
  * Trimming copyright file.
  * Updating upstream links in copyright.
  * Wrap and sorting debian directory.
  * Moving systemd unit directory until debhelper supports
    /usr/lib/systemd/system (Closes: #1034225).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 15 Apr 2023 10:30:08 +0200

=== debian/control ===
Source: nvme-stas
Section: net
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Uploaders:
 Benjamin Drung <bdrung@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 docbook-xml,
 docbook-xsl,
 iproute2,
 libglib2.0-dev-bin,
 meson,
 pyflakes3,
 pylint,
 python3-dasbus,
 python3-gi,
 python3-lxml,
 python3-nvme,
 python3-pyfakefs,
 python3-pyudev,
 python3-systemd,
 python3:any,
 xsltproc,
Standards-Version: 4.6.2
Homepage: https://github.com/linux-nvme/nvme-stas
Rules-Requires-Root: no
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-stas
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-stas

Package: nvme-stas
Architecture: all
Depends:
 python3-dasbus,
 python3-gi,
 python3-nvme,
 python3-pyudev,
 python3-systemd,
 ${misc:Depends},
 ${python3:Depends},
Description: NVMe STorage Appliance Services
 This package provides two daemons, stafd and stacd. The STorage Appliance
 Finder Daemon (stafd) automatically discovers NVMe-oF Discovery Controllers
 (DC) and retrieves the list of NVMe Storage Appliances. The STorage Appliance
 Connector Daemon (stacd) establishes I/O connections to the NVMe Storage
 Appliances discovered by stafd.
 .
 This package installs the library for Python 3.

=== debian/rules ===
--- 
+++ 
@@ -5,3 +5,9 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -Dman=true
+
+execute_after_dh_auto_install:
+	# Moving systemd unit directory (#1034225)
+	mkdir -p debian/nvme-stas/lib/systemd
+	mv debian/nvme-stas/usr/lib/systemd/system debian/nvme-stas/lib/systemd
+	rmdir -p --ignore-fail-on-non-empty debian/nvme-stas/usr/lib/systemd

=== debian/tests/control ===
Test-Command: cp -r test "$AUTOPKGTEST_TMP" && cd "$AUTOPKGTEST_TMP/test" && rm test-avahi.py && python3 -m unittest -v test*.py
Depends:
 iproute2,
 nvme-stas,
 python3-pyfakefs,
Restrictions: allow-stderr
Features: test-name=unittest

## nvme-stas 2.3.1

=== Makefile ===
--- 
+++ 
@@ -26,12 +26,12 @@
 
 .PHONY: stas
 stas: ${BUILD-DIR}
-	ninja -C ${BUILD-DIR}
+	meson compile -C ${BUILD-DIR}
 
 .PHONY: clean
 clean:
 ifneq ("$(wildcard ${BUILD-DIR})","")
-	ninja -C ${BUILD-DIR} -t clean
+	meson compile --clean -C ${BUILD-DIR}
 endif
 
 .PHONY: purge
@@ -46,7 +46,7 @@
 
 .PHONY: uninstall
 uninstall: ${BUILD-DIR}
-	sudo ninja -C ${BUILD-DIR} uninstall
+	sudo ninja $@ -C ${BUILD-DIR}
 
 .PHONY: dist
 dist: stas
@@ -56,6 +56,7 @@
 test: stas
 	meson $@ -C ${BUILD-DIR} --suite nvme-stas
 
+################################################################################
 .PHONY: loc
 loc:
 	@cloc --by-file --exclude-dir=${BUILD-DIR},doc,subprojects,test,utils,debian,obj-x86_64-linux-gnu,.github --exclude-lang=Markdown,"NAnt script",XML,"Bourne Again Shell",make,"Bourne Shell",Meson,YAML,XSLT .

=== doc/readthedocs/Makefile ===
# Minimal makefile for Sphinx documentation
#
.DEFAULT_GOAL := help

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS  ?=
SPHINXBUILD ?= sphinx-build
SOURCEDIR   = .
BUILDDIR    = _build

# Put it first so that "make" without argument is like "make help".
.PHONY: help
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)


# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
.PHONY: Makefile
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
nvme-stas (2.3.1-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 2.3.1: - properly handles big-endian data in
    `iputils.py` (Closes: #1057031).
  * Adding patch from upstream to fix udev tests with dummy interfaces,
    thanks to Olivier Gayot <olivier.gayot@canonical.com> (Closes:
    #1057530).
  * Adding patch from upstream to fix tests with esoteric interface names,
    thanks to Olivier Gayot <olivier.gayot@canonical.com> (Closes:
    #1057530).
  * Adding nvme-cli to autopkg depends, thanks to Olivier Gayot
    <olivier.gayot@canonical.com> (Closes: #1054533).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 10 Dec 2023 11:42:55 +0100

nvme-stas (2.3-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 2.3.
  * Including debian version 2.2.2-2.
  * Removing Fix-byte-ordering-in-iputil-operations.patch, not needed with
    upstream version 2.3.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 25 Sep 2023 10:25:45 +0200

nvme-stas (2.3~rc5-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 2.3~rc5.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 04 Sep 2023 11:21:50 +0200

nvme-stas (2.3~rc4-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 2.3~rc4.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 04 Sep 2023 11:15:33 +0200

nvme-stas (2.3~rc3-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 2.3~rc3.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 06 Aug 2023 09:53:22 +0200

nvme-stas (2.3~rc2-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 2.3~rc2.
  * Moving source lintian-overrides out of its subdirectory for
    consistency reasons.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 14 Jul 2023 07:38:01 +0200

nvme-stas (2.3~rc1-2) experimental; urgency=medium

  * Uploading to experimental.
  * Updating watch file.
  * Updating python3-libnvme build-depends.
  * Sorting control fields in file.
  * Adding binary section in control for consistency.
  * Updating manual python3-libnvme depends.
  * Updating package description.
  * Adjust rules for consistent coding standard.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 24 Jun 2023 07:01:04 +0200

nvme-stas (2.3~rc1-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 2.3~rc1.
  * Avoid failing test suite for this pre-release.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 16 Jun 2023 13:04:11 +0200

=== debian/control ===
Source: nvme-stas
Section: net
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Uploaders:
 Benjamin Drung <bdrung@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 docbook-xml,
 docbook-xsl,
 iproute2,
 libglib2.0-dev-bin,
 meson,
 pyflakes3,
 pylint,
 python3-dasbus,
 python3-gi,
 python3-lxml,
 python3-libnvme,
 python3-pyfakefs,
 python3-pyudev,
 python3-systemd,
 python3:any,
 xsltproc,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/linux-nvme/nvme-stas
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-stas
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-stas

Package: nvme-stas
Section: net
Architecture: all
Depends:
 python3-dasbus,
 python3-gi,
 python3-libnvme,
 python3-pyudev,
 python3-systemd,
 ${misc:Depends},
 ${python3:Depends},
Description: NVMe Storage Appliance Services (STAS)
 NVMe over Fabrics (NVMe-oF) is the concept of using a transport protocol over
 a network to connect remote NVMe devices. nvme-stas contains services to be
 used to access NVMe over TCP:
 .
   * Storage Appliance Finder (stafd):
     automatically locate Central or Direct Discovery Controllers (CDC, DDC)
     with zeroconf (mDNS).
 .
   * Storage Appliance Connector (stacd):
     setup the I/O controller connections to each storage subsystem.

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,13 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --buildsystem=meson+ninja --with python3
+	dh ${@} --buildsystem=meson+ninja --with python3
 
 override_dh_auto_configure:
 	dh_auto_configure -- -Dman=true
+
+override_dh_auto_test:
+	dh_auto_test || true
 
 execute_after_dh_auto_install:
 	# Moving systemd unit directory (#1034225)

=== debian/watch ===
version=4
opts="pgpmode=auto, filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/nvme-stas-$1\.tar\.gz/, \
      uversionmangle=s/(\d)\-?((pre|rc)\d*)$/$1~$2/" \
https://github.com/linux-nvme/nvme-stas/tags .*/v?(\d\S+)\.tar\.gz

## nvme-stas 2.4

=== debian/changelog ===
nvme-stas (2.4-3) sid; urgency=medium

  * Removing autopkgtest for now (Closes: #1101379).

 -- Daniel Baumann <daniel@debian.org>  Wed, 26 Mar 2025 21:03:40 +0100

nvme-stas (2.4-2) sid; urgency=medium

  * Updating vcs fields.

 -- Daniel Baumann <daniel@debian.org>  Mon, 24 Mar 2025 19:14:13 +0100

nvme-stas (2.4-1) sid; urgency=medium

  * Updating to standards version 4.7.1.
  * Updating to standards version 4.7.2.
  * Merging upstream version 2.4.
  * Updating year in upstream copyright for 2025.
  * Removing test-dummy-interfaces.patch, included upstream.
  * Removing skip-esoteric-interfaces.patch, included upstream.

 -- Daniel Baumann <daniel@debian.org>  Mon, 17 Mar 2025 07:20:31 +0100

nvme-stas (2.3.1-4) sid; urgency=medium

  * Updating source url in copyright.
  * Udpating vcs fields.
  * Updating my email address.
  * Trimming debian changelog.
  * Adding debian packaging in copyright.

 -- Daniel Baumann <daniel@debian.org>  Sun, 16 Feb 2025 13:02:07 +0100

nvme-stas (2.3.1-3) sid; urgency=medium

  * Updating to standards-version 4.7.0.

 -- Daniel Baumann <daniel@debian.org>  Thu, 25 Jul 2024 06:41:15 +0200

nvme-stas (2.3.1-2) sid; urgency=medium

  * Moving systemd units to /usr (Closes: #1059429).

 -- Daniel Baumann <daniel@debian.org>  Wed, 06 Mar 2024 07:10:33 +0100

## nvme-stas 2.4.1

=== Makefile ===
--- 
+++ 
@@ -38,6 +38,7 @@
 purge:
 ifneq ("$(wildcard ${BUILD-DIR})","")
 	rm -rf ${BUILD-DIR}
+	meson subprojects purge --confirm
 endif
 
 .PHONY: install
@@ -46,7 +47,8 @@
 
 .PHONY: uninstall
 uninstall: ${BUILD-DIR}
-	sudo ninja $@ -C ${BUILD-DIR}
+	cd ${BUILD-DIR} && sudo meson --internal uninstall
+
 
 .PHONY: dist
 dist: stas
@@ -70,7 +72,7 @@
 	black --diff --color --line-length 120 --skip-string-normalization --extend-exclude="(subprojects|debian|.build)" .
 
 # Coverage requirements:
-#   pip install coverage
+#   apt-get install python3-coverage
 .PHONY: coverage
 coverage: stas
 	cd ${BUILD-DIR} && ./coverage.sh

=== meson_options.txt ===
# -*- mode: meson -*-

option('man',         type: 'boolean', value: false, description: 'build and install man pages')
option('html',        type: 'boolean', value: false, description: 'build and install html pages')
option('readthedocs', type: 'boolean', value: false,  description: 'to be used by Read-The-Docs documentation builder')
option('libnvme-sel', type: 'combo',   value: 'subproject', choices: ['subproject', 'pre-installed'], description: 'Select the libnvme to be used for testing. Either libnvme built as a "subproject", or libnvme already installed on the system.')
option('rt_pymods_reqd', type: 'boolean', value: false,  description: 'Make sure all run-time python modules are installed')

=== debian/changelog ===
nvme-stas (2.4.1-3) sid; urgency=medium

  * Removing rules-requires-root, not needed anymore.
  * Updating watch file to version 5.

 -- Daniel Baumann <daniel@debian.org>  Sat, 08 Nov 2025 09:54:25 +0100

nvme-stas (2.4.1-2) sid; urgency=medium

  * Simplifying watch file.

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 May 2025 07:56:13 +0200

nvme-stas (2.4.1-1) sid; urgency=medium

  * Merging upstream version 2.4.1.

 -- Daniel Baumann <daniel@debian.org>  Sun, 06 Apr 2025 10:20:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: nvme-stas
 Section: net
 Priority: optional
-Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
+Maintainer: Daniel Baumann <daniel@debian.org>
 Uploaders:
  Benjamin Drung <bdrung@debian.org>,
 Build-Depends:
@@ -23,11 +23,10 @@
  python3-systemd,
  python3:any,
  xsltproc,
-Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/linux-nvme/nvme-stas
-Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-stas
-Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-stas
+Vcs-Browser: https://forgejo.debian.net/nvme/nvme-stas
+Vcs-Git: https://forgejo.debian.net/nvme/nvme-stas
 
 Package: nvme-stas
 Section: net

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@} --buildsystem=meson+ninja --with python3

override_dh_auto_configure:
	dh_auto_configure -- -Dman=true

override_dh_auto_test:
	dh_auto_test || true
